/*
  tiltEvtGetEvent.c   (c) 1999 by Till Harbaum

  This program is GPL'd freeware.
*/

#pragma pack(2)
#include <Common.h>
#include <System/SysAll.h>
#include <UI/UIAll.h>

#define NON_PORTABLE
#include <Hardware/Hardware.h>
#include <System/Globals.h>
#include <System/SysEvtMgr.h>
#include <System/KeyMgr.h>

#include "tilthack.h"

#define MAX_TIMEOUT 12

void NewEvtGetEvent(EventPtr event, Long timeout)
{
  DWord orig, buttons;
  struct globals globs;
  short  x, y;
  short sens;

  /* jump to original routine */
  FtrGet('TiHa', 1001, &orig);

  /* get preferences */
  tilt_prefs(&globs);

  /* tilt emulation enabled */
  if(globs.flags & FLAG_EVENT) {
    /* power sensor */
    tilt_power(true);
 
    /* get sensivity level */
    sens = 1+globs.sensivity/3;

    /* get tilt */
    tilt_get(&globs, &x, &y);

    /* map into keys */
    buttons = 0;
    if(y >  sens) buttons |= globs.map[0];
    if(y < -sens) buttons |= globs.map[1];
    if(x < -sens) buttons |= globs.map[2];
    if(x >  sens) buttons |= globs.map[3];

    /* did the buttons change? */
    if(globs.last_key ^ buttons) {

      /* check all buttons masks */
      /* this can be done much nicer with some small arrays, but */
      /* this is impossible in hacks, sicne they don't support   */
      /* preset globals */
      if((buttons & keyBitHard1)&& !(globs.last_key & keyBitHard1))
	EvtEnqueueKey(hard1Chr, 0, 8);

      if((buttons & keyBitHard2)&& !(globs.last_key & keyBitHard2))
	EvtEnqueueKey(hard2Chr, 0, 8);

      if((buttons & keyBitHard3)&& !(globs.last_key & keyBitHard3))
	EvtEnqueueKey(hard3Chr, 0, 8);

      if((buttons & keyBitHard4)&& !(globs.last_key & keyBitHard4))
	EvtEnqueueKey(hard4Chr, 0, 8);

      if((buttons & keyBitPageUp)&& !(globs.last_key & keyBitPageUp))
	EvtEnqueueKey(pageUpChr, 0, 8);

      if((buttons & keyBitPageDown)&& !(globs.last_key & keyBitPageDown))
	EvtEnqueueKey(pageDownChr, 0, 8);

      /* save old buttons state */
      globs.last_key = buttons;
      PrefSetAppPreferences(CREATOR, 0, 0, &globs, sizeof(struct globals), true);
    }

    /* force timeout to short time */
    if((timeout>MAX_TIMEOUT)||(timeout==evtWaitForever))
      timeout = MAX_TIMEOUT;
  } else {
    /* EvtGetEvent is disabled */

    /* power down sensor if KeyCurrentState is disabled, also */
    if(!(globs.flags & FLAG_CURKEY))
      tilt_power(false);
  }
  
  /* jump into original trap */
  ((void(*)(EventPtr, Long))orig)(event, timeout);

  /* power down sensor on power down event */
  if((event->eType == keyDownEvent) && 
     (event->data.keyDown.modifiers & commandKeyMask) &&
     ((event->data.keyDown.chr == autoOffChr) ||
      (event->data.keyDown.chr == hardPowerChr)))
    tilt_power(false);
}

#include "tilt_p3.c"
