/*
  tiltKeyCurrentState.c   (c) 1999 by Till Harbaum

  This program is GPL'd freeware.
*/

#pragma pack(2)
#include <Common.h>
#include <System/SysAll.h>
#include <UI/UIAll.h>

#define NON_PORTABLE
#include <Hardware/Hardware.h>
#include <System/Globals.h>
#include <System/SysEvtMgr.h>

#include "tilthack.h"

DWord NewKeyCurrentState(void) {
  DWord orig, new;
  struct globals globs;
  short  x, y;
  short sens;

  /* jump to original routine */
  FtrGet(CREATOR, 1000, &orig);
  orig = ((DWord(*)(void))orig)();

  /* get preferences */
  tilt_prefs(&globs);

  if(globs.flags & FLAG_CURKEY) {
    /* power sensor */
    tilt_power(true);

    sens = 1+globs.sensivity/3;

    /* get tilt */
    tilt_get(&globs, &x, &y);

    /* map tilt to keys */

    /* exclusive report only of axis more tilted */
    if((!(globs.flags & FLAG_REP_EXCL))||( abs(x)<=abs(y))) {
      if(y >  sens) orig |= globs.map[0];
      if(y < -sens) orig |= globs.map[1];
    }

    if((!(globs.flags & FLAG_REP_EXCL))||( abs(x)>=abs(y))) {
      if(x < -sens) orig |= globs.map[2];
      if(x >  sens) orig |= globs.map[3];
    }

    /* report pressed keys only once? */ 
    if(globs.flags & FLAG_REP_ONCE) {

      /* any recently pressed button? */
      new = (globs.last_key ^ orig) & orig;

      if(new) {      
	/* save old buttons state */
	globs.last_key = orig;
	PrefSetAppPreferences(CREATOR, 0, 0, &globs, sizeof(struct globals), true);

	/* return only recently pressed buttons */
	orig = new;
      } else 
	orig = 0;
    }
  }

  return orig;
}

#include "tilt_p3.c"

