/*
  tilt hack configuration interface 

  (c) 1999 by Till 'Tilt' Harbaum

  This program is GPL'd freeware.
*/

#pragma pack(2)
#include <Pilot.h>
#include <System/KeyMgr.h>

#include "tilthack.h"

void  key2gui(DWord key, FormPtr frm, Word lst);
DWord gui2key(FormPtr frm, Word lst);
void  draw_sensivity(int val);

Boolean eventhandle(EventPtr event)
{
  struct globals globs;   /* global variables */
  Word x, y;
  FormPtr form = FrmGetActiveForm();
  int tilt_state;
  
  /* init sensor hardware */
  tilt_state = tilt_init(&globs);

  /* get preferences */
  tilt_prefs(&globs);

  switch (event->eType) {

  case frmOpenEvent:
    FrmDrawForm(form);

    if(tilt_state) FrmAlert(1111);

    /* set check boxes */
    CtlSetValue(FrmGetObjectPtr (form, FrmGetObjectIndex (form, 3020)), 
		globs.flags & FLAG_CURKEY);

    CtlSetValue(FrmGetObjectPtr (form, FrmGetObjectIndex (form, 3021)), 
		globs.flags & FLAG_EVENT);

    CtlSetValue(FrmGetObjectPtr (form, FrmGetObjectIndex (form, 3022)), 
		globs.flags & FLAG_REP_ONCE);

    CtlSetValue(FrmGetObjectPtr (form, FrmGetObjectIndex (form, 3023)), 
		globs.flags & FLAG_REP_EXCL);

    /* set key mapping selectors */
    key2gui(globs.map[0], form, 3040);
    key2gui(globs.map[1], form, 3042);
    key2gui(globs.map[2], form, 3044);
    key2gui(globs.map[3], form, 3046);

    draw_sensivity(globs.sensivity);

    return 1;

  case ctlSelectEvent:
    switch(event->data.ctlEnter.controlID) {
      
    case 3001:  /* zero button */
      /* get zero values */
      tilt_zero(&globs);
      PrefSetAppPreferences(CREATOR, 0, 0, &globs, sizeof(struct globals), true);
      return 1;
      break;

    case 3002:  /* zero button */
      /* get sensor values */
      tilt_get(&globs, &x, &y);
      PrefSetAppPreferences(CREATOR, 0, 0, &globs, sizeof(struct globals), true);
      return 1;
      break;

    case 3030:
      /* set gui stuff */
      globs.flags = 0;
      if(CtlGetValue(FrmGetObjectPtr (form, FrmGetObjectIndex (form, 3020)))) 
	globs.flags |= FLAG_CURKEY;

      if(CtlGetValue(FrmGetObjectPtr (form, FrmGetObjectIndex (form, 3021))))
	globs.flags |= FLAG_EVENT;

      if(CtlGetValue(FrmGetObjectPtr (form, FrmGetObjectIndex (form, 3022))))
	globs.flags |= FLAG_REP_ONCE;

      if(CtlGetValue(FrmGetObjectPtr (form, FrmGetObjectIndex (form, 3023))))
	globs.flags |= FLAG_REP_EXCL;

      globs.map[0] = gui2key(form, 3040);
      globs.map[1] = gui2key(form, 3042);
      globs.map[2] = gui2key(form, 3044);
      globs.map[3] = gui2key(form, 3046);

      PrefSetAppPreferences(CREATOR, 0, 0, &globs, sizeof(struct globals), true);
 
    case 3031:
      FrmGotoForm(9000);
      return 1;
      break;

    }

  case ctlRepeatEvent:
    switch(event->data.ctlEnter.controlID) {
    case 3010:
      globs.sensivity--;
      if(globs.sensivity<1) globs.sensivity=1;
      goto save_me;
      
    case 3011:
      globs.sensivity++;
      if(globs.sensivity>45) globs.sensivity=45;
save_me:
      draw_sensivity(globs.sensivity);
      PrefSetAppPreferences(CREATOR, 0, 0, &globs, sizeof(struct globals), true);
      break;
    }
    break;
    
  default:
  }

  FrmHandleEvent(form, event);
  return 1;
}

void key2gui(DWord key, FormPtr frm, Word list) {
  int idx=0;
  ListPtr lst;

  if(key & keyBitHard1)    idx = 1;  /* Datebook */
  if(key & keyBitHard2)    idx = 2;  /* Address  */
  if(key & keyBitPageUp)   idx = 3;  /* Up       */
  if(key & keyBitPageDown) idx = 4;  /* Down     */
  if(key & keyBitHard3)    idx = 5;  /* ToDo     */
  if(key & keyBitHard4)    idx = 6;  /* Memopad  */

  lst = FrmGetObjectPtr (frm, FrmGetObjectIndex (frm, list+1));
  LstSetSelection(lst, idx);
  CtlSetLabel(FrmGetObjectPtr (frm, FrmGetObjectIndex (frm, list)), 
	      LstGetSelectionText(lst, idx));
}

DWord gui2key(FormPtr frm, Word list) {
  ListPtr lst;
  int idx;
  DWord k=0;

  lst = FrmGetObjectPtr (frm, FrmGetObjectIndex (frm, list+1));
  idx = LstGetSelection(lst);

  if(idx == 1) k = keyBitHard1;     /* Datebook */
  if(idx == 2) k = keyBitHard2;     /* Address  */
  if(idx == 3) k = keyBitPageUp;    /* Up       */
  if(idx == 4) k = keyBitPageDown;  /* Down     */
  if(idx == 5) k = keyBitHard3;     /* ToDo     */
  if(idx == 6) k = keyBitHard4;     /* Memopad  */

  return k;
}

void draw_sensivity(int val) {
  char str[5];

  /* redraw value (ugly too, but again my problem with globals ...) */
  if(val<10) {
    StrIToA(&str[2], val);
    str[0]=str[1]=str[3]=' '; str[4]=0;
  } else
    StrIToA(str, val);
  
  FntSetFont(1);
  WinDrawChars(str, StrLen(str), 115, 104);
}    

#include "tilt_p3.c"

